package com.example.switchyard.bpm;

import static org.switchyard.component.bpm.BPMConstants.CORRELATION_KEY_PROPERTY;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.cdi.CDIMixIn;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(mixins = CDIMixIn.class, config = SwitchYardTestCaseConfig.SWITCHYARD_XML)
public class ProcessServiceTest {

	@ServiceOperation("ProcessService")
	private Invoker service;

	@Test
	public void testSubmit() throws Exception {
	    
	    Request submit_1 = new Request();
	    submit_1.setName("Dustin");
	    submit_1.setRequestType("FOO");
	    RequestAck result_1 = service.operation("submit").property(CORRELATION_KEY_PROPERTY, "1234").sendInOut(submit_1).getContent(RequestAck.class);
	    Assert.assertTrue(result_1.isAccepted());

	    Request submit_2 = new Request();
	    submit_2.setName("David");
	    submit_2.setRequestType("BOO");
	    RequestAck result_2 = service.operation("submit").property(CORRELATION_KEY_PROPERTY, "5678").sendInOut(submit_2).getContent(RequestAck.class);
	    Assert.assertTrue(result_2.isAccepted());

	    Object finish = null;
	    service.operation("finish").property(CORRELATION_KEY_PROPERTY, "1234").sendInOnly(finish);
	    //service.operation("finish").property(CORRELATION_KEY_PROPERTY, "5678").sendInOnly(finish);
	    //service.operation("finishAll").sendInOnly(finish);
	    
	}

	// @Test
	// public void testFinish() throws Exception {
	// // TODO Auto-generated method stub
	// // initialize your test message
	// Object message = null;
	// service.operation("finish").sendInOnly(message);
	//
	// // validate the results
	// Assert.assertTrue("Implement me", false);
	// }
	

}
